# Principia Open Source Project
![Principia](https://raw.githubusercontent.com/Bithack/principia/master/data-src/github-image0.gif)

Principia is a sandbox physics game originally released in November 2013. It is the successor to the 2011 Android hit game "Apparatus". In August of 2022 Principia was released as open source, and is now being developed as an open source project by the Principia community.

Principia runs on anything with a recent enough version of Windows, Linux or Android. Experimental ports to Haiku OS and macOS are also available, and work to port Principia to other platforms are very welcome.

## Useful Links
* New community site: https://principia-web.se

* Download: https://principia-web.se/download

* Old community site archive: https://archive.principia-web.se

* Wiki: https://principia-web.se/wiki/

* Forum: https://principia-web.se/forum/

* Discord server: https://principia-web.se/discord

* Codeberg mirror: https://codeberg.org/principia/principia

* Mastodon: https://fosstodon.org/@principia

## Binary builds
Binary builds of Principia for Windows, Android and Linux are available on the [downloads page](https://principia-web.se/download).

There are also nightly build artifacts for Windows, Android and Linux that get automatically built by GitHub CI on each commit, see [Actions](https://github.com/Bithack/principia/actions). Keep in mind these may be broken at times during development, and you are recommended to use the release builds instead.

## Getting involved
Feel free to fork this project and send in your pull requests. This is a community project and the community decides how the project evolves.

Most of our discussion and development happens in the `#development` channel of the [Principia Discord server](https://principia-web.se/discord), make sure to join it if you want to discuss and participate in the development of the game.

Also be sure to follow [@principia](https://fosstodon.org/@principia) on Fosstodon for more updates about the project.

## Building from source
See [Compiling Principia](https://principia-web.se/wiki/Compiling_Principia) on the Principia Wiki.

(You can also view the plaintext Markdown document [here](https://raw.githubusercontent.com/principia-game/wiki/master/pages/Compiling_Principia.md))

## License
See [LICENSE.md](LICENSE.md)
