# Principia Android Dependency Buildscripts
Scripts to build Principia Android dependencies.

Forked off of [Minetest's Android dependency buildscripts](https://github.com/minetest/minetest_android_deps).

## Usage
Generally you would use the prebuilt static libraries generated by Github Actions, which gets automatically downloaded by Gradle while building the Android version. Nothing else needs to be done.

However if you're adding new dependencies, updating existing ones, or are building the dependencies locally you can manually run the build script, `./build.sh <target> <architecture>`. Keep in mind you will need the location to the Android NDK in the ANDROID_NDK env variable (e.g. /opt/android-sdk/ndk/21.4.7075529/`).

The architecture can be either `armeabi-v7a` (32-bit ARM), `arm64-v8a` (64-bit ARM), `x86` (32-bit x86) or `x86_64` (64-bit x86). Target can be either a specific dependency (see `scripts/`) or `--all` to build all dependencies.

To build with locally built dependencies ignoring the ones available remotely, you can symlink `/principia-src/build-android/deps` to `/principia-deps/deps`.
